local totals = {0,0,0,0,0,0,0,0,0,0,0,0}
local grand_total = 0; local count = 0;
local months = {"Jan", "Feb", "Mar" , "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"}
local yearly = '';
local labels = '';
local zeros = '';
local progress = '';

function handle_record(record)
    local year_total = 0
    for i=1,12 do
        year_total = year_total +  record:get(months[i]);
        record:set(months[i], record:get(months[i]));
        totals[i] = totals[i] + record:get(months[i]);
    end
    count = count +1;
    record:set("YEAR_TOTAL", year_total)
--    yearly = yearly .. format_num(year_total, 2, '€', '-') .. ',';
    yearly = yearly .. year_total .. ',';
    zeros = zeros .. '0,';
    labels = labels .. record:get('YEAR') .. ','; 
    grand_total = grand_total + year_total;
    progress = progress .. grand_total .. ',';
end

function complete(result)
    yearly = '{title:"Year total",fillColor : "rgba(151,187,205,0.2)", strokeColor : "rgba(151,187,205,1)", pointColor : "rgba(151,187,205,1)",pointStrokeColor:"#fff",pointHighlightFill: "#fff",pointHighlightStroke: "rgba(151,187,205,1)", data : [' .. string.sub(yearly,1,-2) .. ']}';
    progress = '{title:"Yearly progress",fillColor : "rgba(220,220,220,0.2)", strokeColor : "rgba(220,220,220,1)", pointColor : "rgba(220,220,220,1)",pointStrokeColor:"#fff",pointHighlightFill: "#fff",pointHighlightStroke: "rgba(220,220,220,1)", data : [' .. string.sub(progress,1,-2) .. ']}';
    zeros = '{strokeColor : "rgba(0,0,0,1)", data : [' .. string.sub(zeros,1,-2) .. ']}';
    for i=1,12 do
         result:set("AVERAGE_" .. months[i], math.floor(totals[i]/count));
    end

    result:set("GRAND_TOTAL", grand_total);
    result:set('YEARLY', yearly);
    result:set('PROGRESS',progress);
    result:set('LABELS',  string.sub(labels,1,-2) );
    result:set('ZEROS',  zeros );
end

-- from sam_lie
-- Compatible with Lua 5.0 and 5.1.
-- Disclaimer : use at own risk especially for hedge fund reports :-)

---============================================================
-- add comma to separate thousands
-- 
function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1.%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

---============================================================
-- rounds a number to the nearest decimal places
--
function round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

--===================================================================
-- given a numeric value formats output with comma to separate thousands
-- and rounded to given decimal places
--
--
function format_num(amount, decimal, prefix, neg_prefix)
  local str_amount,  formatted, famount, remain

  decimal = decimal or 2  -- default 2 decimal places
  neg_prefix = neg_prefix or "-" -- default negative sign

  famount = math.abs(round(amount,decimal))
  famount = math.floor(famount)

  remain = round(math.abs(amount) - famount, decimal)

        -- comma to separate the thousands
  formatted = comma_value(famount)

        -- attach the decimal portion
  if (decimal > 0) then
    remain = string.sub(tostring(remain),3)
    formatted = formatted .. "," .. remain ..
                string.rep("0", decimal - string.len(remain))
  end

        -- attach prefix string e.g '$' 
  formatted = (prefix or "") .. formatted 

        -- if value is negative then format accordingly
  if (amount<0) then
    if (neg_prefix=="()") then
      formatted = "("..formatted ..")"
    else
      formatted = neg_prefix .. formatted 
    end
  end

  return formatted
end